#include <stdio.h>
#include <string.h>
#define UNINW  99
#define UW2  UNINW/2
#define  n1  4096                  // max cols
#define  n2  1024                  // mac rows
#define  XP  1                     // if xp
int rows,cols,o_cols, work[n1],work1[500];
unsigned char obits[n2][n1];       // raw data
unsigned char  bits[n2][n1],wb[n1];// work pic
unsigned char a[n1],a1[n1],a2[n1]; // extract 3 strips
unsigned char       a3[n1],a4[n1]; // extract 2 strips
unsigned short  h[539];            // BMP head
FILE *fp,*fp1;
float fc;                          // slip
char sb[80],sf[80];                // sb: outcode array, <80 char.
int u1,u2,v1,v2,z0,z1,z2,zz;       // 1st corner position of pixel
int x1,x2,x3,x4,y1,y2,y3,y4;       // 2nd corner position of bits file

int P=0,no128=0,shift=3;           // if pdf417.par existed, readpar
int simple=0;                      // 0: find corner...;   1: simple
int nbar,id;

#define m60           240          //
#define m40           128         //
int  mtab[108]={ 0x212222, 0x222122, 0x222221, 0x121223, 0x121322, 0x131222,
       0x122213, 0x122312, 0x132212, 0x221213, 0x221312, 0x231212, 0x112232,
       0x122132, 0x122231, 0x113222, 0x123122, 0x123221, 0x223211, 0x221132,
       0x221231, 0x213212, 0x223112, 0x312131, 0x311222, 0x321122, 0x321221,
       0x312212, 0x322112, 0x322211, 0x212123, 0x212321, 0x232121, 0x111323,
       0x131123, 0x131321, 0x112313, 0x132113, 0x132311, 0x211313, 0x231113,
       0x231311, 0x112133, 0x112331, 0x132131, 0x113123, 0x113321, 0x133121,
       0x313121, 0x211331, 0x231131, 0x213113, 0x213311, 0x213131, 0x311123,
       0x311321, 0x331121, 0x312113, 0x312311, 0x332111, 0x314111, 0x221411,
       0x431111, 0x111224, 0x111422, 0x121124, 0x121421, 0x141122, 0x141221,
       0x112214, 0x112412, 0x122114, 0x122411, 0x142112, 0x142211, 0x241211,
       0x221114, 0x413111, 0x241112, 0x134111, 0x111242, 0x121142, 0x121241,
       0x114212, 0x124112, 0x124211, 0x411212, 0x421112, 0x421211, 0x212141,
       0x214121, 0x412121, 0x111143, 0x111341, 0x131141, 0x114113, 0x114311,
       0x411113, 0x411311, 0x113141, 0x114131, 0x311141, 0x411131, 0x211412,
       0x211214, 0x211232, 0x233111,           0x211133};

int readp(char *a, char *b, int m, int *j)
{
  int i; for(i=0;i<m;i++)if(a[i]!=b[i])break;
  sscanf(&a[10],"%d",j);  return i/m;
}

readpar()
{
  int j,k;
  fp=fopen("c://pdf417.par","r");
  if(fp){ k=0;
l01:
    fgets(sb,80,fp);  if(feof(fp))goto l02;      // # pdfmap
    if(sb[0]=='#'){ if(k==1)goto l02; if(sb[5]=='1')k=1; goto l01; }
    if(sb[0]<=32 || k==0)goto l01;               // allowed blank_line
    if(k){                                       // no matter of order
      if(readp(sb,"print",5,&j))P=j;
      if(readp(sb,"no128",5,&j))no128=j;
      if(readp(sb,"simple",6,&j))simple=j;
    }
    goto l01;
l02: fclose(fp);
    if(P)printf("par:\tno128 %d  simple %d\n",no128,simple);
  }
}

do_bar()
{
  int i,j,k, barlen;
  pre_job();
  if(simple){
    j=rows/2;
    for(i=0;i<cols;i++){
      a[i]=bits[j][i]; a1[i]=bits[j-shift][i]; a2[i]=bits[j+shift][i];
                       a3[i]=bits[j-shift*2][i]; a4[i]=bits[j+shift*2][i];
    }
  } else {
    findxy();                    // workout fc,z0,v1
    for(i=0;i<cols;i++){ k=z0+fc*(i-v1);
      a[i]=bits[k][i]; a1[i]=bits[k-shift][i]; a2[i]=bits[k+shift][i];
                       a3[i]=bits[k-shift*2][i]; a2[i]=bits[k+shift*2][i];
    }
  }
  id=0; barlen=BarCode(a);
  if(shift) {
    if(barlen<=0){ if(P)printf("%d  ",barlen);  id=-1; barlen=BarCode(a1);  }
    if(barlen<=0){ if(P)printf("%d  ",barlen);  id= 1; barlen=BarCode(a2);  }
    if(barlen<=0){ if(P)printf("%d  ",barlen);  id=-2; barlen=BarCode(a3);  }
    if(barlen<=0){ if(P)printf("%d  ",barlen);  id= 2; barlen=BarCode(a4);  }
  }
  return(barlen);
}

BarCode(unsigned char *b)
{
  int  i,j,k,zm;
  j=m60; k=0;
  for(i=10;i<cols-10;i++){
    if(b[i]>=m40){                         // find high peak's min
      if(b[i]>=b[i-1] && b[i]>=b[i+1] && b[i]<j)j=b[i];
    } else {                               //  find low peak's min
      if(b[i]<=b[i-1] && b[i]<=b[i+1] && b[i]>k)k=b[i];
    }
  }
  zm=(j+k)/2;
          // printf("min_high_peak,max_low_peak,threshold: %d %d %d\n",j,k,zm);
  k=nbar=0;
  for(i=0;i<cols;i++){
    if(k==0 && b[i]<zm)continue;                   // pass white_head
    if(k==0){ work[nbar++]=calm(b,i,zm); k=1; }
    if(k==1){
      if(b[i]<zm){ work[nbar++]=calm(b,i,zm)-1; k=2; }
      continue;
    }
    if(k==2) if(b[i]>zm){ work[nbar++]=calm(b,i,zm); k=1; }
  }
  return(bar128());
}

bar128()
{
  int  i,j,k,zm, jp, checkcode, codesort,  i1,i2,cc[6];
  float  aa[6],scale;     //  printf("how many white_black_bar: %d\n",nbar);
  if(nbar<19){                     if(P)printf(" too short ");   return(-6); }
  if(P)printf(" %d* ",nbar-1);
/*
printf("\n");
for(i=0;i<nbar;i++){ if(i%15==0)printf("\n"); printf("%4d ",work[i]); }
printf("\n");for(i=0;i<nbar-1;i++){
if(i%15==0)printf("\n"); printf("%4d ",work[i+1]-work[i]); }
*/
  k=work[1]-work[0];

//printf("\nk: %d\n",k);
  if(k>70){
  for(i=0;i<nbar-1;i++)work1[i]=work[i+1]-work[i];
  for(i=1;i<nbar-2;i++)if(work1[i]<=16){
    if(work1[i-1]>32 && work1[i+1]>32){ work[i]=work[i+1]=0; }
    else {
      j=i;    if(work1[i-1]>work1[i+1])j++;
      if(work[j-1]==0)j--;    work[j-1]=work[j+1]=0;
    }
    i+=2;
  }
  for(i=0;i<nbar;i++)work1[i]=work[i];
  for(i=j=0;i<nbar;i++)if(work1[i])work[j++]=work1[i]; nbar=j;
  }
/*
printf("\n");
for(i=0;i<nbar;i++){ if(i%15==0)printf("\n"); printf("%4d ",work[i]); }
printf("\n");for(i=0;i<nbar-1;i++){
 if(i%6==0)printf("\n"); printf("%4d ",work[i+1]-work[i]); }
*/
  test2();

  nbar--;
  if(nbar%6!=1) {                  if(P)printf(" not 128code "); return(-5); }
  zm=(work[nbar-1]-work[0])/(11*(nbar/6));           //  printf(" %d ",zm);
  for(i=1;i<=nbar;i++){                              // too narrow "1" adjust
    k=work[i]-work[i-1];
    if(k<(zm*3/4)){  k=(zm-k)/2;  work[i]+=k;  work[i-1]-=k; }
  }
  for(i=0;i<nbar;i++)work[i]=work[i+1]-work[i];
  if(work[3]<work[nbar-4])                       //  printf("bar revered! ");
    for(i=0;i<nbar/2;i++){j=nbar-i-1; k=work[i]; work[i]=work[j]; work[j]=k;}
  for(i=0;i<nbar;i+=6){   i1=i2=0;
    scale=(work[i]+work[i+1]+work[i+2]+work[i+3]+work[i+4]+work[i+5])/11.;
    for(j=i;j<i+6;j++){
      aa[i1]=work[j]/scale+.5;    work[j]=aa[i1];
      if(work[j]==0)work[j]=1;    if(work[j]>=5)work[j]=4;
      i2+=work[j];                aa[i1++]-=work[j];
    }
    if(i2==10 || i2==12){
      for(i1=0;i1<6;i1++)cc[i1]=i1;   sort(aa,cc);
      if(i2==10)work[i+cc[0]]++;      if(i2==12)work[i+cc[5]]--;
    }
  }
  for(i=jp=j=0;i<nbar;i+=6){
    for(k=zm=0;k<6;k++){zm<<=4; zm+=work[j++];}   work[jp++]=zm;
  }
  jp--;
              // for(i=0;i<jp;i++)printf("%x ",work[i]); printf("\n");
  checkcode=0;
/*
 printf("\n");
  for(i=0;i<jp;i++)printf("%x ",work[i]);
*/
  for(i=k=0;i<jp;i++){
    for(j=0;j<107;j++)if(work[i]==mtab[j])goto l10;
            if(P)printf("\n%d %x\n",i,work[i]);
                                if(P)printf(" no code "); return(-1);
l10:
    work[k++]=j;
  }
  codesort=work[0]-102;  k--;
  if(codesort<1 || codesort>3){ if(P)printf(" no head "); return(-2);}
  if(work[k]!=106){             if(P)printf(" no end ");  return(-3);}
  for(i=1;i<k;i++)checkcode+=work[i-1]*(i-1);  checkcode+=work[0];
  checkcode%=103;        k--;
  if(checkcode!=work[k]){       if(P)printf(" crc err "); return(-4);}
  for(i=1,jp=0;i<k;i++) if(codesort==3){
    if(work[i]>=100)codesort=2;
    else {  sb[jp++]=work[i]/10+48;  sb[jp++]=work[i]%10+48; }
  } else {  if(work[i]==99)codesort=3;    else sb[jp++]=work[i]+32;  }
  return(jp);
}

calm(unsigned char *b, int i, int zm)
{
  if(b[i]==b[i-1])return i<<4;
  return  (i<<4)-((b[i]-zm)<<4)/(b[i]-b[i-1]);
}

sort(float *a, int *c)
{
  int i,j,k;  float x;
  for(i=0;i<5;i++)for(j=i+1;j<6;j++)if(a[i]<a[j]){
    x=a[i]; a[i]=a[j]; a[j]=x;
    k=c[i]; c[i]=c[j]; c[j]=k;
  }
}

pre_job()
{
  int i,j;
  for(j=0;j<rows;j++){                            // erase_black_edge
    for(i=0;i<cols;i++)if(obits[j][i]>UNINW)break; else obits[j][i]=255;
    for(i=cols-1;i>0;i--)if(obits[j][i]>UNINW)break; else obits[j][i]=255;
  }
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)bits[j][i]=255-obits[j][i];
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)if(bits[j][i]<3)bits[j][i]=0;
}

corner(u,v,x,y,zx,zy)                // input: u,v; output: x,y
int u,v,zx,zy, *x,*y;                // zx,zy  4 corner direction
{
  int i,j,k,p,q,r,s,t;
  for(r=0;r<rows/4*3;r++)for(j=0;j<=r;j++)for(i=0;i<=r;i++)if(i+j==r){
    s=u+i*zx; t=v+j*zy;
    if(s<0)s=0; if(s>cols-1)s=cols-1;
    if(t<0)t=0; if(t>rows-1)t=rows-1;
    if(bits[t][s]){  k=0;
      for(q=0;q<5;q++)for(p=0;p<5;p++)if(bits[t+q*zy][s+p*zx])k++;
      if(k>=22)goto l10;             // allowed apear 3 0 in 25 data
    }
  }
l10:                           // distance 3 pixel of corner. find X,Y edge
  s+=zx*3; t+=zy*3;
  for(j=0;j<8;j++){ q=t-j*zy; if(q<0 || q>=rows-1)break; if(!bits[q][s])break; }
  for(i=0;i<8;i++){ p=s-i*zx; if(p<0 || p>=cols-1)break; if(!bits[t][p])break; }
  *x=p+zx;  *y=q+zy;
}

false_corner()
{
  int i,j,k=0;
  float f1,f2,fx;
  i=x1-x2-x3+x4;  if(i<0)i=-i;
  j=y1-y2-y3+y4;  if(j<0)j=-j;
  if(i+j<6)goto l98;
  i=y2-y1; j=y4-y3;
  if(i>j){  k=1;   fx=j; fx=(x3-x4)/fx;  }
    else {  k=3;   fx=i; fx=(x1-x2)/fx;  }
  f1=y3-y1; f1=f1/(x3-x1)-fx; if(f1<0)f1=-f1;
  f2=y4-y2; f2=f2/(x4-x2)-fx; if(f2<0)f2=-f2;
  if(f2>f1)k++;
  if(P)printf("false_corner: %d ***\n",k);
l98:
  return k;
}

findxy()
{
  int i,j,k;
// find 4 corner, roughly
  for(j=0;j<rows;j++)work[j]=0;               // project in X
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)if(bits[j][i]>UNINW)work[j]+=UW2;
  for(j=0;j<rows;j++)work[j]/=cols;
  for(j=0;j<rows/2;j++)     if(work[j]&&work[j+1])break; v1=j;
  for(j=rows-1;j>rows/2;j--)if(work[j]&&work[j-1])break; v2=j;
//for(j=0;j<rows;j++)printf("%d ",work[j]); printf("\n");
  for(i=0;i<cols;i++)work[i]=0;                         // project in Y
  for(i=0;i<cols;i++)for(j=0;j<rows;j++)if(bits[j][i]>UNINW)work[i]+=UW2;
  for(i=0;i<cols;i++)work[i]/=rows;
  for(i=0;i<cols/2;i++)     if(work[i]&&work[i+1])break; u1=i;
  for(i=cols-1;i>cols/2;i--)if(work[i]&&work[i-1])break; u2=i;
//for(i=0;i<cols;i++)printf("%d ",work[i]); printf("\n");
//printf("u1,u2  v1,v2: %d %d    %d %d\n",u1,u2,v1,v2);
// locate 4 corner in detail
  corner(u1,v1,&x1,&y1, 1, 1);   //0,0  ------>
  corner(u1,v2,&x2,&y2, 1,-1);   // |   x1,y1         x3,y3
  corner(u2,v1,&x3,&y3,-1, 1);   // |
  corner(u2,v2,&x4,&y4,-1,-1);   // v   x2,y2         x4,y4
// printf("1,2,3,4:  %d_%d  %d_%d  %d_%d  %d_%d\n",x1,y1,x2,y2,x3,y3,x4,y4);
// if too slip, de_false_corner
  k=false_corner();
  j=(y2+y4-y1-y3)/4;  if(k==1 || k==2)j=(y4-y3)/2;
                      if(k==3 || k==4)j=(y2-y1)/2;
  z0=y1+j; if(k==1)z0=y2-j;
  fc=y3-y1; fc/=(x3-x1);
  if(k==1 || k==3){ fc=y4-y2; fc/=(x4-x2); }
  v1=x1; if(k==1)v1=x2;
}

main(int ac, char **av)
{
  int   i,j,k,ip=0;
  readpar();
  if(ac<2){
    printf("\n\t********** precess bar128 image ***********\n");
    printf("\n\t                       jiang zhaoji 2011118\n");
    printf("\n\tUsage: bar128   file#.[bmp]\n");
    printf("\n\tex:    bar128    c00 !");
    printf("\n\tex:    bar128    c#\n");
    return 0;
  }
  if(no128)system("mkdir no128");
  strcpy(sb,av[1]);
  for(i=0;i<strlen(sb);i++)if(sb[i]=='.')sb[i]=0;
  for(i=0;i<strlen(sb);i++)if(sb[i]=='#')sb[i]='*';
  if(XP)sprintf(sf,"dir/b %s.bmp >bar128.tmp",sb);
  else  sprintf(sf,"ls %s.bmp >bar128.tmp",sb); system(sf);
  fp1=fopen("bar128.tmp","r");
  goto l100;
l99:
  if(no128){ if(XP)sprintf(sb,"move %s no128",sf);
             else  sprintf(sb,"mv %s no128",sf); system(sb); }
l100:
  fgets(sf,80,fp1); ip++;
  if(feof(fp1)){ fclose(fp1);
    if(XP)system("del bar128.tmp");
    else  system("rm bar128.tmp"); return 0; }
  k=strlen(sf); sf[k-1]=0;
  printf("%3d: %s ",ip,sf);
  fp=fopen(sf,"rb"); if(fp==0){printf(" file not found!\n");  goto l100; }
  fread(h,2,539,fp);
  if(h[14]!=8){ fclose(fp); printf(" not 256 gray BMP!\n"); goto l99; }
  for(i=0;i<256;i++)if((h[27+i*2]>>8)!=i){
                fclose(fp); printf(" is 256 color BMP!\n"); goto l99; }
  cols=h[9]; rows=h[11]; k=(cols+3)/4*4;
  if(cols>n1)cols=n1; o_cols=cols; if(rows>n2)rows=n2;

  for(j=0;j<rows;j++)fread(obits[rows-j-1],1,k,fp); fclose(fp);
  if(P)printf("size: %d*%d  ",cols,rows);

  k=do_bar();
  if(k>0)for(i=0;i<k;i++)printf("%c",sb[i]);  else if(P)printf("%d ",k);
  printf("\n");
  goto l100;
}

cross(int x, int y, int color)               // plot cross mark.
{
  int i,j;
  for(j=y-5;j<=y+5;j++)if(j>=0 && j<n2)bits[j][x]=color;
  for(i=x-5;i<=x+5;i++)if(i>=0 && i<n1)bits[y][i]=color;
}

outbmp(char *f)                     // output bits_file with mark & curve
{
  FILE *fp;
  int i,j,k=(o_cols+3)/4*4;
// define color;
  h[535]=0xff00; h[536]=0;                     // coror 1: green
  h[533]=0;                                    // color 2: red
  fp=fopen(f,"wb");  fwrite(h,2,539,fp);
  for(j=0;j<rows;j++)for(i=0;i<o_cols;i++)obits[j][i]=255-bits[j][i];
  for(j=0;j<rows;j++)fwrite(obits[rows-j-1],1,k,fp);
  fclose(fp);
}

test2()
{
  int i,j,k,m;
  if(id==0){
    if(zz)cross(z1,z2, 2);
    cross(u1,v1,2);  cross(u1,v2,2);  cross(u2,v1,2);  cross(u2,v2,2);
    cross(x1,y1,1);  cross(x2,y2,1);  cross(x3,y3,1);  cross(x4,y4,1);
    for(i=0;i<o_cols;i++){ k=z0+fc*(i-x1);  bits[k][i]=1; }
  }
  for(j=0;j<nbar;j++){
    i=work[j]>>4; k=z0+fc*(i-x1)+id*shift+1; bits[k][i]=2;
  }
  outbmp("b.bmp");
}
